package org.eclipse.jdt.internal.compiler.parser;

package .tmp;

import org.eclipse.jdt.internal.compiler.parser.Parser;
import org.eclipse.jdt.internal.compiler.parser.Scanner;

final class VanguardParser extends Parser {
  public static final boolean SUCCESS = true;
  
  public static final boolean FAILURE = false;
  
  Scanner.Goal currentGoal;
  
  public VanguardParser(Scanner.VanguardScanner scanner) {
    this.scanner = (Scanner)scanner;
  }
  
  protected boolean parse(Scanner.Goal goal) {
    this.currentGoal = goal;
    try {
      int act = 1580;
      this.stateStackTop = -1;
      this.currentToken = goal.first;
      label40: while (true) {
        int stackLength = this.stack.length;
        if (++this.stateStackTop >= stackLength)
          System.arraycopy(
              this.stack, 0, 
              this.stack = new int[stackLength + 255], 0, 
              stackLength); 
        this.stack[this.stateStackTop] = act;
        act = Parser.tAction(act, this.currentToken);
        if (act == 16382)
          return false; 
        if (act <= 800) {
          this.stateStackTop--;
        } else if (act > 16382) {
          this.unstackedAct = act;
          try {
            this.currentToken = this.scanner.getNextToken();
          } finally {
            this.unstackedAct = 16382;
          } 
          act -= 16382;
        } else {
          if (act < 16381) {
            this.unstackedAct = act;
            try {
              this.currentToken = this.scanner.getNextToken();
            } finally {
              this.unstackedAct = 16382;
            } 
            continue;
          } 
          return false;
        } 
        while (true) {
          if (goal.hasBeenReached(act, this.currentToken))
            return true; 
          this.stateStackTop -= Parser.rhs[act] - 1;
          act = Parser.ntAction(this.stack[this.stateStackTop], Parser.lhs[act]);
          if (act > 800)
            continue label40; 
        } 
        break;
      } 
    } catch (Exception exception) {
      return false;
    } 
  }
  
  public String toString() {
    return "\n\n\n----------------Scanner--------------\n" + this.scanner.toString();
  }
}
